twitter-conduit-0.5.0: Twitter API package with conduit interface and Streaming API support.

Safe Haskell | None
Language | Haskell2010

Web.Twitter.Conduit.Request.Internal

Contents

- Orphan instances

# Documentation

data Param label t Source #

Constructors

label := t |

type EmptyParams = '[] :: [Param Symbol *] Source #

type HasParam (label :: Symbol) (paramType :: *) (params :: [Param Symbol *]) = ParamType label params ~ paramType Source #

type family ParamType (label :: Symbol) (params :: [Param Symbol *]) :: * where ... Source #

Equations

ParamType label ((label := paramType) ': ks) = paramType |
ParamType label ((label' := paramType') ': ks) = ParamType label ks |

type APIQuery = [APIQueryItem] Source #

type APIQueryItem = (ByteString, PV) Source #

data PV Source #

Constructors

PVInteger |

Fields

- unPVInteger :: Integer

PVBool |

Fields

- unPVBool :: Bool

PVString |

Fields

- unPVString :: Text

PVIntegerArray |

Fields

- unPVIntegerArray :: [Integer]

PVStringArray |

Fields

- unPVStringArray :: [Text]

PVDay |

Fields

- unPVDay :: Day

#### Instances

Instances details

Eq PV Source # |
Instance details Defined in Web.Twitter.Conduit.Request.Internal Methods (==) :: PV -> PV -> Bool (/=) :: PV -> PV -> Bool
Show PV Source # |
Instance details Defined in Web.Twitter.Conduit.Request.Internal Methods showsPrec :: Int -> PV -> ShowS show :: PV -> String showList :: [PV] -> ShowS

class Parameters req where Source #

Associated Types

type SupportParameters req :: [Param Symbol *] Source #

Methods

params :: Lens' req APIQuery Source #

#### Instances

Instances details

Parameters (APIRequest supports responseType) Source # |
Instance details Defined in Web.Twitter.Conduit.Request Associated Types type SupportParameters (APIRequest supports responseType) :: [Param Symbol Type] Source # Methods params :: Lens' (APIRequest supports responseType) APIQuery Source #

class ParameterValue a where Source #

Methods

wrap :: a -> PV Source #

unwrap :: PV -> a Source #

#### Instances

Instances details

ParameterValue Bool Source # |
Instance details Defined in Web.Twitter.Conduit.Request.Internal Methods wrap :: Bool -> PV Source # unwrap :: PV -> Bool Source #
ParameterValue Integer Source # |
Instance details Defined in Web.Twitter.Conduit.Request.Internal Methods wrap :: Integer -> PV Source # unwrap :: PV -> Integer Source #
ParameterValue Text Source # |
Instance details Defined in Web.Twitter.Conduit.Request.Internal Methods wrap :: Text -> PV Source # unwrap :: PV -> Text Source #
ParameterValue Day Source # |
Instance details Defined in Web.Twitter.Conduit.Request.Internal Methods wrap :: Day -> PV Source # unwrap :: PV -> Day Source #
ParameterValue [Integer] Source # |
Instance details Defined in Web.Twitter.Conduit.Request.Internal Methods wrap :: [Integer] -> PV Source # unwrap :: PV -> [Integer] Source #
ParameterValue [Text] Source # |
Instance details Defined in Web.Twitter.Conduit.Request.Internal Methods wrap :: [Text] -> PV Source # unwrap :: PV -> [Text] Source #

makeSimpleQuery :: APIQuery -> SimpleQuery Source #

paramValueBS :: PV -> ByteString Source #

rawParam Source #

Arguments

:: (Parameters p, ParameterValue a) |
=> ByteString | key
-> Lens' p (Maybe a) |

# Orphan instances

(Parameters req, ParameterValue a, KnownSymbol label, HasParam label a (SupportParameters req), Functor f, lens ~ ((Maybe a -> f (Maybe a)) -> req -> f req)) => IsLabel label lens Source # |
Instance details Methods fromLabel :: lens